<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  AnchorDropdown,
  CTA as CallToAction,
  Copy,
  CopyMedia,
} from '../components/common/index.vue';
import { getHelpDataHelper } from '../services/get-help.service';
import { CONTENT_TYPES } from '../common/content-types';
import { MenuComponent as SideMenu } from '~/components/side-menu/index.vue';
import { getPageMetadata } from '~/common/meta';
import { getClient } from '~/plugins/contentful.js';
import { LivePreviewMixin } from '~/mixins';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { ContentfulLivePreview } from '@contentful/live-preview';

// Argo <-> Contentful intergration complete
export default Vue.extend({
  name: 'GetHelp',
  components: {
    AnchorDropdown,
    CallToAction,
    Copy,
    CopyMedia,
    SideMenu,
  },
  mixins: [LivePreviewMixin],
  async asyncData({ i18n }) {
    const locale = convertToCaseSensitiveLocale(i18n.locale);

    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'get-help',
        include: 3,
        locale,
      });

      const { pageContent } = items[0].fields;
      const seoMetadata = items[0].fields.seoMetadata[0].fields;

      const doc = getHelpDataHelper(pageContent);
      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };
      return { items, doc, metadata };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    const { sideMenu } = this.$refs;
    document.addEventListener('scroll', () => {
      if (window.scrollY >= 4380) {
        sideMenu.$el.style.display = 'none';
      } else sideMenu.$el.style.display = 'block';
    });

    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.doc = getHelpDataHelper(updatedData[0].fields.pageContent)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <SlpContainer>
    <SideMenu
      v-if="doc.side_menu"
      ref="sideMenu"
      :links="doc.side_menu.links"
    />
    <anchor-dropdown
      :options="doc.side_menu.links"
      fixed
      label="On this page: "
    />
    <SlpColumn :cols="10" size="xl">
      <component
        :is="component.name"
        v-for="component in doc.components"
        :key="component.name"
        :data="component.data"
      />
    </SlpColumn>
  </SlpContainer>
</template>

<style scoped lang="scss"></style>
